	.include "p30f2012.inc"
	.global __reset
	.global XIN,YIN,ZIN
	.global XINB,YINB,ZINB
	.global HXINB,HYINB,HZINB
	.global HXINB2,HYINB2,HZINB2
        .global XACCB
        .global XHOSEIG,YHOSEIG,ZHOSEIG
        .global GBUF,XBUF,YBUF,ZBUF,HXYZIN

__reset:
	mov	#stack,w15
	bset.b	CORCONL,#PSV

	mov	#0xfc3f,w0	;portB direction
	mov	w0,TRISB
	mov	#0xdfff,w0	;portC direction
	mov	w0,TRISC
	mov	#0xfdff,w0	;portD direction
	mov	w0,TRISD
	mov	#0xffc3,w0	;portF direction
	mov	w0,TRISF

	call	ADinit
	call	lcd_init	;LCD initialize
	call	HyojiInit
	call	Hyoji

	mov	#XIN,w4
	mov	#0x20,w0
	repeat	#15
	mov	w0,[w4++]	; clear
	clr	w0
	repeat	#(stack-XIN)/2-1
	mov	w0,[w4++]	; clear

;------------------------------
; C
;------------------------------
hajime:
	btsc	PORTB,#3	;{^ꂽ
	call	initG2		;̂Ƃ̒llƂċL
	mov	#512,w4
	mov	#XINB,w2
	clr	w0
	repeat	#5
	mov	w0,[w2++]
adl:				;Ϗ
	call	GetAD
	mov	#XINB,w2
;x axis
	mov	XIN,w0
	lac	w0,B
	sftac	B,#9
	lac	[w2++],A
	mov	[w2--],w0
	mov	w0,ACCAL
	add	A
	sac	A,[w2++]
	mov	ACCAL,w0
	mov	w0,[w2++]
;y axis
	mov	YIN,w0
	lac	w0,B
	sftac	B,#9
	lac	[w2++],A
	mov	[w2--],w0
	mov	w0,ACCAL
	add	A
	sac	A,[w2++]
	mov	ACCAL,w0
	mov	w0,[w2++]
;z axis
	mov	ZIN,w0
	lac	w0,B
	sftac	B,#9
	lac	[w2++],A
	mov	[w2--],w0
	mov	w0,ACCAL
	add	A
	sac	A,[w2++]
	mov	ACCAL,w0
	mov	w0,[w2++]

	call	w4us
	dec	w4,w4
	bra	nz,adl


	call	HoseiOfs	;ZT̃ItZbg␳
	call	HoseiG		;ZT̃QC␳

;-------------------------------------
;32avZ
;-------------------------------------
	clr	B
	mov	HXINB2+2,w4
	mov	HYINB2+2,w5
	mov	HZINB2+2,w6
;x axis
	mov	HXINB2,w7
	mul.us	w4,w7,w0
	lac	w1,A
	mov	w0,ACCAL
	add	B
	add	B
;y axis
	mov	HYINB2,w7
	mul.us	w5,w7,w0
	lac	w1,A
	mov	w0,ACCAL
	add	B
	add	B
;z axis
	mov	HZINB2,w7
	mul.us	w6,w7,w0
	lac	w1,A
	mov	w0,ACCAL
	add	B
	add	B

	mov	#1,w0			;ۂ
	add	W0,#2,B
	sftac	B,#15

	mov	#HXINB2+4,w8
	mov	[w8-4],w4
	mac	w4*w4,B, [w8]+=4,w4
	mac	w4*w4,B, [w8],w4
	mac	w4*w4,B

	sac	B,w0
	mov	w0,HXYZIN
	mov	ACCBL,w0
	mov	w0,HXYZIN+2

;-------------------------------------
; 2a̍̌vZ
;-------------------------------------
	mov	GBUF,w0
	lac	w0,A
	mov	GBUF+2,w0
	mov	w0,ACCAL
	mov	HXYZIN,w0
	lac	w0,B
	mov	HXYZIN+2,w0
	mov	w0,ACCBL
	sub	B
	btsc	ACCBH,#15
	clr	B
	mov	#-2,w0
	add	w0,#0,B
	sac	B,w0
	mov	w0,GI1
	mov	ACCBL,w1
	mov	w1,GI1+2

;-------------------------------------
; ̌vZ
;̌vZs
;
; 1) V:=0.8494-x/2/2
; 2) V:=V*(0.6965 -x*V/2)*2
; 3) y:=x*V*2
; 4) V:=V*(0.75-y*V/2)*2
; 5) y:=x*V*2
; 6) V:=V*(0.75-y*V/2)*2
; 7) y:=x*V*2
; 8) y:=y+V*(x-y*y)
;-------------------------------------
	mov	#psvpage(RTCST),w0
	mov	w0,_PSVPAG
	mov	#psvoffset(RTCST),w8
	mov	#GI1,w11
	mov	[w11++],w1
	lac	w1,A
	mov	[w11--],w0
	mov	w0,ACCAL	;A=x
;O
	ff1l	w1,w2		;leading zero̐𐔂
	bra	nc,$+10
	ff1l	w0,w2
	bra	nc,$+4
	bra	sqfin
	add	#16,w2

	lsr	w2,#1,w2
	sl	w2,#1,w2	;ɂ
	sub	#2,w2
	mov	w2,SFT

	cp	w2,#0
	bra	z,$+8
	sub	#1,w2
	repeat	w2
	sftac	A,#-1
	sac	A,w10
	mov	ACCAL,w11	;w10:w11=x
;1)V:=0.8494-x/4
	sftac	A,#2		;A=x/4
	lac	[w8++],B	;萔
	mov	[w8++],w0
	mov	w0,ACCBL	;0.8494
	sub	B		;V:=0.8494-x/4
;2)V:=V*(0.6965 -x/2*V)*2
	lac	w10,A
	mov	w11,ACCAL	;A=x
	sftac	A,#1		;A=x/2
	sac	A,w5
	mov	ACCAL,w1	;w5:w1=x/2
	sac	B,w4
	mov	ACCBL,w0	;w4:w0=V
	mul.us	w0,w5,w2
	mul.us	w1,w4,w6
	lac	w3,A
	mov	w2,ACCAL
	lac	w7,B
	mov	w6,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A		;A=x/2*V
	lac	[w8++],B
	mov	[w8++],w1	;B=0.6965
	mov	w1,ACCBL
	sub	B		;B=(0.6965-x/2*V)
	sac	B,w5
	mov	ACCBL,w1	;w5:w1=(0.6965-x/2*V)
	mul.us	w1,w4,w2	;w4:w0=V
	mul.us	w0,w5,w6
	lac	w3,A
	mov	w2,ACCAL
	lac	w7,B
	mov	w6,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A
	sftac	A,#-1		;A:V=V*(0.6965 -x/2*V)*2
;3)y:=x*V*2
	mov	w10,w5		;w5:w1=
	mov	w11,w1
	sac	A,w4
	mov	ACCAL,w0	;w4:w0=V
	mul.us	w1,w4,w2
	mul.us	w0,w5,w6
	lac	w3,B
	mov	w2,ACCBL
	lac	w7,A
	mov	w6,ACCAL
	add	A
	sftac	A,#16
	mac	w5*w4,A
	sftac	A,#-1		;A:y=x*V*2
;4)V:=V*(0.75-y*V/2)*2
	sac	A,w5
	mov	ACCAL,w1	;w5:w1=y
	mul.us	w0,w5,w2
	mul.us	w1,w4,w6
	lac	w3,A
	mov	w2,ACCAL
	lac	w7,B
	mov	w6,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A
	sftac	A,#1		;A=y*V/2
	lac	[w8],B
	clr	ACCBL		;B=0.75
	sub	B		;B=0.75-y*V/2
	sac	B,w5
	mov	ACCBL,w1
	mul.us	w0,w5,w2
	mul.us	w1,w4,w6
	lac	w3,A
	mov	w2,ACCAL
	lac	w7,B
	mov	w6,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A
	sftac	A,#-1		;A:V=V*(0.75-y*V/2)
;5)y:=x*V*2
	mov	w10,w5		;w5:w1=
	mov	w11,w1
	sac	A,w4
	mov	ACCAL,w0	;w4:w0=V
	mul.us	w1,w4,w2
	mul.us	w0,w5,w6
	lac	w3,B
	mov	w2,ACCBL
	lac	w7,A
	mov	w6,ACCAL
	add	A
	sftac	A,#16
	mac	w5*w4,A
	sftac	A,#-1		;A:y=x*V*2
;6)V:=V*(0.75-y*V/2)*2
	sac	A,w5
	mov	ACCAL,w1	;w5:w1=y
	mul.us	w0,w5,w2
	mul.us	w1,w4,w6
	lac	w3,A
	mov	w2,ACCAL
	lac	w7,B
	mov	w6,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A
	sftac	A,#1		;A=y*V/2
	lac	[w8],B
	clr	ACCBL		;B=0.75
	sub	B		;B=0.75-y*V/2
	sac	B,w5
	mov	ACCBL,w1
	mul.us	w0,w5,w2
	mul.us	w1,w4,w6
	lac	w3,A
	mov	w2,ACCAL
	lac	w7,B
	mov	w6,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A
	sftac	A,#-1		;A:V=V*(0.75-y*V/2)*2
;7)y:=x*V*2
	mov	w10,w5		;w5:w1=x
	mov	w11,w1
	sac	A,w4
	mov	ACCAL,w0	;w4:w0=V
	mul.us	w1,w4,w2
	mul.us	w0,w5,w6
	lac	w3,B
	mov	w2,ACCBL
	lac	w7,A
	mov	w6,ACCAL
	add	A
	sftac	A,#16
	mac	w5*w4,A
	sftac	A,#-1		;A:y=x*V*2
;8)y:=y+V*(x-y*y) 
	sac	A,w6
	mov	ACCAL,w7	;w6:w7=y
	mul.us	w7,w6,w2
	lac	w3,B
	mov	w2,ACCBL
	sftac	B,#15
	mac	w6*w6,B		;B=y*y
	lac	w5,A
	mov	w1,ACCAL	;A=x
	sub	A		;A=(x-y*y)
	sac	A,w5
	mov	ACCAL,w1	;w5:w1=(x-y*y)
	mul.us	w1,w4,w2	;w4:w0=V
	mul.us	w0,w5,w12
	lac	w3,A
	mov	w2,ACCAL
	lac	w13,B
	mov	w12,ACCBL
	add	A
	sftac	A,#16
	mac	w4*w5,A		;A=V*(x-y*y)
	lac	w6,B
	mov	w7,ACCBL	;B=y
	add	A		;A=y+V*(x-y*y)
;XP[O
	mov	SFT,w2
	cp	w2,#0
	bra	z,sqfin
	asr	w2,#1,w2
	sub	#1,w2
	repeat	w2
	sftac	A,#1
sqfin:	sac	A,w0
	mov	w0,GI2
	mov	ACCAL,w0
	mov	w0,GI2+2
;()̏C
	mov	YBUF,w0
	lac	w0,A
	mov	YBUF+2,w0
	mov	w0,ACCAL	;A=Y(n-1)
	mov	YINB,w0
	lac	w0,B
	mov	YINB+2,w0	;A=Y(n)
	mov	w0,ACCBL
	sub	B		;B=Y(n)-Y(n-1)
	mov	GI2,w0
	lac	w0,A
	mov	GI2+2,w0
	mov	w0,ACCAL
	btss	ACCBH,#15
	neg	A
	sac	A,w0
	mov	w0,GI2
	mov	ACCAL,w0
	mov	w0,GI2+2

;-------------------------------------
; xxϕ
;-------------------------------------
sokudo:
	clr	B
	mov	GI2,w0
	lac	w0,A
	mov	GI2+2,w0
	mov	w0,ACCAL
;ʌvZ
	mov	#XACCB,w4	;AL[^
	mov	[w4++],w0
	mov	w0,ACCBH
	mov	[w4--],w0
	mov	w0,ACCBL
	add	B		;ACCB += u
	mov	ACCBH,w0	;AL[^ʕۑ
	mov	w0,[w4++]
	mov	ACCBL,w0
	mov	w0,[w4++]
;ʌvZ
	mov	ACCBU,w0
	lac	w0,B
	lac	[w4],A		;AL[^
	add	A		;Z
	sac	A,[w4]		;AL[^ʕۑ

;-------------------------------------
; x\֕ϊ
;-------------------------------------
DISP:	mov	#psvpage(SCCST),w0
	mov	w0,_PSVPAG
	mov	#psvoffset(SCCST),w9
	mov	#XACCB,w8

	mov	[w8],w4		;w4=ul
	mov	[w9++],w5	;w5=k11
	mul.us	w4,w5,w0
	lac	w1,A
	mov	w0,ACCAL
	sftac	A,#16

	mov	[w8+4],w4	;w4=uh
	mac	w4*w5,A, [w9]+=2,w7	;w7=k12
	sftac	A,w7

	sac	A,w0
	mov	w0,VMPS
	mov	ACCAL,w0
	mov	w0,VMPS+2

	mov	[w8],w4		;w4=ul
	mov	[w9++],w5	;w5=k12
	mul.us	w4,w5,w0
	lac	w1,A
	mov	w0,ACCAL
	sftac	A,#16

	mov	[w8+4],w4	;w4=ul
	mac	w4*w5,A, [w9]+=2,w7	;
	sftac	A,w7

	sac	A,w0
	mov	w0,VKMPH
	mov	ACCAL,w0
	mov	w0,VKMPH+2

	mov	VMPS,w3	;\
	mov	#MOJI+11,w4
	call	Bin2Dec
	mov	VKMPH,w3
	mov	#MOJI+27,w4
	call	Bin2Dec

	call	Hyoji
	goto	hajime

RTCST:	.word	0x6CB9,0x23A2	;0.8494
	.word	0x5926,0xE978	;0.6965
	.word	0x6000,0x0000	;0.75

SCCST:
	.word	0x7FD6,-1	;m/sւ̕ϊW,EVtg
				; =3.80987e-6[m/s/LSB]
	.word	0x730D,-3	;km/hւ̕ϊW,EVtg
				; =13.715532e-6[km/h/LSB]

;-------------------------------------
;ϐ
;-------------------------------------
.section *,xmemory
MOJI:	.space	32
XIN:	.space	2	;ADf[^
YIN:	.space	2
ZIN:	.space	2
XINB:	.space	4	;ςADf[^
YINB:	.space	4
ZINB:	.space	4
HXINB:	.space	4	;ItZbg␳ADf[^
HYINB:	.space	4
HZINB:	.space	4
HXINB2:	.space	4	;QC␳ADf[^
HYINB2:	.space	4
HZINB2:	.space	4
HXYZIN:	.space	4	;x^2
XBUF:	.space	4	;Xx̊l
YBUF:	.space	4	;Yx̊l
ZBUF:	.space	4	;Zx̊l
GBUF:	.space	4	;x^2̊l
SFT:	.space	2	;ėʈꎞL
GI1:	.space	4	;2a̍
GI2:	.space	4	;
XACCB:	.space	6
VMPS:	.space	4
VKMPH:	.space	4
stack:	.space	0

.section *,ymemory
XHOSEIG:	.space	2
YHOSEIG:	.space	2
ZHOSEIG:	.space	2

	.END

